<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import Checkbox from '@/components/general/form/Checkbox.vue';
import Range from '@/components/general/form/Range.vue';
import { computed, ref, watch } from 'vue';

const props = defineProps<{
    presets: any[]
}>();

const isAdditionalSettingsOpen = defineModel('open');
const temperature = defineModel('temperature');
const top_p = defineModel('top_p');

const localPreset = ref(props.presets[0].name);
const description = ref(props.presets[0].description);

const preset = computed({
    get(){
        return localPreset.value;
    },
    set(value){
        localPreset.value = value;
        const findPreset = props.presets.find((item:any)=>item.name === value);
        if(findPreset){
            temperature.value = findPreset.temp;
            top_p.value = findPreset.top_p;
        }else{
            description.value = undefined;
        }
    }
});

watch([temperature, top_p], ([newTemp, newTopP]) => {
    const matchingPreset = props.presets.find(
        (item:any) => item.temp === newTemp && item.top_p === newTopP
    );
    
    if (matchingPreset) {
        localPreset.value = matchingPreset.name;
        description.value = matchingPreset.description;
    } else {
        localPreset.value = 'custom';
        description.value = undefined;
    }
});

</script>
<template>
<div>
    <Checkbox v-model="isAdditionalSettingsOpen" :label="$t('ai.general.variables.expertMode.checkbox.label')"/>
    <div class="flex flex-col gap-1 mt-2" v-if="isAdditionalSettingsOpen">
        <div class="w-full" v-if="presets.length>1">
            <label class="flex flex-row gap-2 mb-1">{{ $t('ai.general.variables.expertMode.preset.label') }}: <Tooltip :tooltip="description" v-if="description"><i class="ri-information-2-line cursor-pointer"></i></Tooltip></label>
            <select class="border border-gray-300 rounded-md resize-none p-2 text-black focus:outline-none focus-within:outline-none -mt-1 w-full" v-model="preset">
                <option :key="`preset_${idx}`" :value="item.name" v-for="item, idx in presets">{{ item.label }}</option>
                <option value="custom">{{ $t('ai.general.variables.expertMode.preset.custom') }}</option>
            </select>
        </div>
        <Range v-model="temperature" :label="$t('ai.general.variables.expertMode.preset.temperature')" :min="0" :max="2" :step="0.1"/>
        <Range v-model="top_p" :label="$t('ai.general.variables.expertMode.preset.topP')" :min="0" :max="1" :step="0.1" />
    </div>
</div>
</template>